/*
 * This file is generated by jOOQ.
 */
package de.ship.db.tables;


import de.ship.db.CommonDd;
import de.ship.db.tables.records.VCoreValueDeDeRecord;

import java.util.Collection;

import org.jooq.Condition;
import org.jooq.Field;
import org.jooq.Name;
import org.jooq.PlainSQL;
import org.jooq.QueryPart;
import org.jooq.SQL;
import org.jooq.Schema;
import org.jooq.Select;
import org.jooq.Stringly;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class VCoreValueDeDe extends TableImpl<VCoreValueDeDeRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>common_dd.v_core_value_de_de</code>
     */
    public static final VCoreValueDeDe V_CORE_VALUE_DE_DE = new VCoreValueDeDe();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<VCoreValueDeDeRecord> getRecordType() {
        return VCoreValueDeDeRecord.class;
    }

    /**
     * The column <code>common_dd.v_core_value_de_de.value_lang</code>.
     */
    public final TableField<VCoreValueDeDeRecord, String> VALUE_LANG = createField(DSL.name("value_lang"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>common_dd.v_core_value_de_de.varvalue</code>.
     */
    public final TableField<VCoreValueDeDeRecord, Integer> VARVALUE = createField(DSL.name("varvalue"), SQLDataType.INTEGER, this, "");

    /**
     * The column <code>common_dd.v_core_value_de_de.value_order</code>.
     */
    public final TableField<VCoreValueDeDeRecord, Integer> VALUE_ORDER = createField(DSL.name("value_order"), SQLDataType.INTEGER, this, "");

    /**
     * The column <code>common_dd.v_core_value_de_de.fk_value_valuelist</code>.
     */
    public final TableField<VCoreValueDeDeRecord, Integer> FK_VALUE_VALUELIST = createField(DSL.name("fk_value_valuelist"), SQLDataType.INTEGER, this, "");

    /**
     * The column <code>common_dd.v_core_value_de_de.de_de</code>.
     */
    public final TableField<VCoreValueDeDeRecord, String> DE_DE = createField(DSL.name("de_de"), SQLDataType.CLOB, this, "");

    private VCoreValueDeDe(Name alias, Table<VCoreValueDeDeRecord> aliased) {
        this(alias, aliased, (Field<?>[]) null, null);
    }

    private VCoreValueDeDe(Name alias, Table<VCoreValueDeDeRecord> aliased, Field<?>[] parameters, Condition where) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.view("""
        create view "v_core_value_de_de" as  SELECT t_core_valueparam.param_key AS value_lang,
          t_core_value.varvalue,
          t_core_value.value_order,
          t_core_value.fk_value_valuelist,
          t_core_translation.value AS de_de
         FROM ((common_dd.t_core_value
           LEFT JOIN common_dd.t_core_valueparam ON ((t_core_value.pk_core_value = t_core_valueparam.fk_valueparam_value)))
           LEFT JOIN common_dd.t_core_translation ON ((t_core_valueparam.param_key = t_core_translation.fk_trans_key)))
        WHERE (((t_core_translation.isocode = 'de_DE'::common_dd.enum_isocode) AND (t_core_translation.category = 'crf'::common_dd.enum_trans_category)) OR (t_core_translation.isocode IS NULL) OR (t_core_valueparam.param_key IS NULL));
        """), where);
    }

    /**
     * Create an aliased <code>common_dd.v_core_value_de_de</code> table
     * reference
     */
    public VCoreValueDeDe(String alias) {
        this(DSL.name(alias), V_CORE_VALUE_DE_DE);
    }

    /**
     * Create an aliased <code>common_dd.v_core_value_de_de</code> table
     * reference
     */
    public VCoreValueDeDe(Name alias) {
        this(alias, V_CORE_VALUE_DE_DE);
    }

    /**
     * Create a <code>common_dd.v_core_value_de_de</code> table reference
     */
    public VCoreValueDeDe() {
        this(DSL.name("v_core_value_de_de"), null);
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : CommonDd.COMMON_DD;
    }

    @Override
    public VCoreValueDeDe as(String alias) {
        return new VCoreValueDeDe(DSL.name(alias), this);
    }

    @Override
    public VCoreValueDeDe as(Name alias) {
        return new VCoreValueDeDe(alias, this);
    }

    @Override
    public VCoreValueDeDe as(Table<?> alias) {
        return new VCoreValueDeDe(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public VCoreValueDeDe rename(String name) {
        return new VCoreValueDeDe(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public VCoreValueDeDe rename(Name name) {
        return new VCoreValueDeDe(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public VCoreValueDeDe rename(Table<?> name) {
        return new VCoreValueDeDe(name.getQualifiedName(), null);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreValueDeDe where(Condition condition) {
        return new VCoreValueDeDe(getQualifiedName(), aliased() ? this : null, null, condition);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreValueDeDe where(Collection<? extends Condition> conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreValueDeDe where(Condition... conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreValueDeDe where(Field<Boolean> condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VCoreValueDeDe where(SQL condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VCoreValueDeDe where(@Stringly.SQL String condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VCoreValueDeDe where(@Stringly.SQL String condition, Object... binds) {
        return where(DSL.condition(condition, binds));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VCoreValueDeDe where(@Stringly.SQL String condition, QueryPart... parts) {
        return where(DSL.condition(condition, parts));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreValueDeDe whereExists(Select<?> select) {
        return where(DSL.exists(select));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreValueDeDe whereNotExists(Select<?> select) {
        return where(DSL.notExists(select));
    }
}
